Subject: Re: bug#65305: 29.1; archive-mode can not handle subfile names encoded with utf-8

From: Eli Zaretskii <[email-masked]>
Date: Tue, 15 Aug 2023 17:50:03 +0300

> From: [email-masked]
> Cc: [email-masked]
> Date: Tue, 15 Aug 2023 22:53:01 +0900
> 
> Eli Zaretskii <[email-masked]> writes:
> 
> > Is there any way of distinguishing these Python-created ZIP archives
> > from ZIP archives created by other Windows programs?
> >
> > Emacs by default assumes that file names in a ZIP archive created by a
> > Windows program are encoded in the console codepage, and it enforces
> > using that encoding for file names when the "creator" of the ZIP
> > archive indicates the archive was created by Windows programs such as
> > InfoZip's zip.exe and the File Explorer.  In my testing, zip archives
> > created by Python as above record the "creator" as number 0 (zero),
> > which is identical to what InfoZip does.  So, unless someone explains
> > how to distinguish these zip archives from those created by InfoZip, I
> > don't see how can Emacs know whether to use the InfoZip heuristics or
> > the Python heuristics.  Without the InfoZip/File Explorer heuristics
> > we have in arc-mode.el today, Emacs on Windows would be completely
> > unable to support non-ASCII file names in ZIP archives.
> 
> There is a bit flag indicating that the subfile name is encoded with
> utf-8. Bytes 6-7 in local file header or bytes 8-9 in central directory
> header are general purpose bit flag. And bit 11 of the flag represents
> file encoding flag(1 for utf-8 encoding).

Thanks, please try the patch below.  If it gives good results, I will
install it.

> I guess unzip.exe does not support utf-8 encoded subfile name.
> Writing batch file with utf-8 encoding:
>   c:\Emacs\emacs-29.1\bin\unzip.exe test.zip 一.txt
> and run with chcp 932, 荳\200.txt is extracted.
> With chcp 65001, extraction failed.
> 
> Writing batch file with cp932 encoding:(same as above)
>   c:\Emacs\emacs-29.1\bin\unzip.exe test.zip 一.txt
> and run with chcp 65001, 荳\200.txt is extracted.
> With chcp 932, extraction failed.
> This is not an ideal behavior, but extraction to STDOUT may work.
> 
> To the contrary, 7z.exe extracts 一.txt correctly.
> If batch file is encoded with utf-8, it works with chcp 65001.
> If batch file is encoded with cp932, it works with chcp 932.

Like I said: support for UTF-8 encoded file names on Windows is
sporadic and incomplete.  It will remain so until Windows file-related
APIs support UTF-8 encoded file names.

diff --git a/lisp/arc-mode.el b/lisp/arc-mode.el
index 5e696c0..05a71fb 100644
--- a/lisp/arc-mode.el
+++ b/lisp/arc-mode.el
@@ -1990,6 +1990,7 @@ archive-zip-summarize
     (setq p (+ p (point-min)))
     (while (string= "PK\001\002" (buffer-substring p (+ p 4)))
       (let* ((creator (get-byte (+ p 5)))
+             (gpflags (archive-l-e (+ p 8) 2))
 	     ;; (method  (archive-l-e (+ p 10) 2))
              (modtime (archive-l-e (+ p 12) 2))
              (moddate (archive-l-e (+ p 14) 2))
@@ -2001,7 +2002,12 @@ archive-zip-summarize
              (efnname (let ((str (buffer-substring (+ p 46) (+ p 46 fnlen))))
 			(decode-coding-string
 			 str
-                         (or (if (and w32-fname-encoding
+                         ;; Bit 11 of general purpose bit flags (bytes
+                         ;; 8-9) of Central Directory: 1 means UTF-8
+                         ;; encoded file names.
+                         (or (if (/= 0 (logand gpflags #x0800))
+                                 'utf-8-unix)
+                             (if (and w32-fname-encoding
                                       (memq creator
                                             ;; This should be just 10 and
                                             ;; 14, but InfoZip uses 0 and